#include "Span.hpp"

int	main(void) {

	std::cout << "\n---Test0---\n" << std::endl;
	{
		Span spa0(0);

		try {
			spa0.addNumber(4);
		}
		catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}

	std::cout << "\n---Test1---\n" << std::endl;
	{
		Span spa(10);

		spa.addNumber(6);
		spa.addNumber(3);
		spa.addNumber(17);
		spa.addNumber(9);
		spa.addNumber(11);
		std::cout << "spa: 6, 3, 17, 9, 11" << std::endl;
		std::cout << spa.shortestSpan() << std::endl;
		std::cout << spa.longestSpan() << std::endl;
	}

	std::cout << "\n---Test2---\n" << std::endl;
	{
		Span spa(10);

		spa.addNumber(-5);
		spa.addNumber(5);

		std::cout << "spa: -5, 5" << std::endl;

		std::cout << spa.shortestSpan() << std::endl;
		std::cout << spa.longestSpan() << std::endl;
	}


	std::cout << "\n---Test3---\n" << std::endl;
	{
		Span spa(5);
		srand(time(NULL));

		for (int i = 0; i < 5; i++) {
			int number = (rand() % 20) - 10;
			std::cout << "spa[" << i << "]: " << number << ", ";
			spa.addNumber(number);
		}
		std::cout << "\n";

		std::cout << spa.shortestSpan() << std::endl;
		std::cout << spa.longestSpan() << std::endl;
	}

	std::cout << "\n---EndTest---\n" << std::endl;
}
